// hresult.cs
using System;
using System.Runtime.InteropServices;
#if !V10 && !V11
using System.Runtime.ConstrainedExecution;
#endif
namespace HongliangSoft.Utilities.Unmanaged.ComHelpers {
	///<summary>COM ̃C^[tFCXbvA^CĂяo\bp[i RCW j̎QƃJEg̊Ǘ܂B</summary>
	///<remarks>
	///  <para>COM IuWFNgɂ Marshal.ReleaseComObject Ăяo RCW ̎QƃJEgfNgKv܂A <see cref="ComInterfaceWrapper"/> ܂͂̔hNXŃC^[tFCXbvƁADispose \bȟĂяoA܂̓t@CiCUɂ Marshal.ReleaseComObject Ăяo悤ɂȂ܂B</para>
	///  <para>܂̃NX <see cref="CheckHR(HResult)"/> / <see cref="CheckHR(int)"/> \bhhNXɑ΂ČJAHRESULT ɂG[OƂđôɕ֗Ȏi񋟂܂B</para>
	///</remarks>
	public class ComInterfaceWrapper
#if !V10 && !V11
		: CriticalFinalizerObject, IDisposable
#else
		: IDisposable
#endif
	{
		///<summary>
		///bv COM IuWFNgw肵ăCX^X쐬܂B
		///</summary>
		///<param name="comObj">bv COM IuWFNgB</param>
		///<exception cref="ArgumentNullException"><paramref name="comObj"/>  null w肳܂B</exception>
		public ComInterfaceWrapper(object comObj) {
			if (comObj == null)
				throw new ArgumentNullException("comObj", "null QƂ炱̃CX^X邱Ƃ͂ł܂B");
			this.handle = GCHandle.Alloc(comObj);
		}
		private GCHandle handle;
		///<summary>
		///w肵 HResult G[\ĂƂAΉO𓊂܂B
		///</summary>
		///<param name="result">G[\ <see cref="HResult"/> B</param>
		///<remarks>
		///  <para>HRESULT ɑΉOɂẮA.NET Framework ̃hLgQƂĂB</para>
		///</remarks>
		public void CheckHR(HResult result) {
			this.CheckHR((int)result);
		}
		///<summary>
		///w肵 HResult G[\ĂƂAΉO𓊂܂B
		///</summary>
		///<param name="hResult">G[\ <see cref="HResult"/> B</param>
		///<remarks>
		///  <para>HRESULT ɑΉOɂẮA.NET Framework ̃hLgQƂĂB</para>
		///</remarks>
		public void CheckHR(int hResult) {
			if (hResult != 0) {
				Marshal.ThrowExceptionForHR(hResult);
			}
		}
		///<summary>̃IuWFNg COM IuWFNg擾܂B</summary>
		///<exception cref="ObjectDisposedException">łɂ̃IuWFNg͔jĂ܂B</exception>
		public object Instance {
			get {
				if (!(this.handle.IsAllocated) || this.handle.Target == null)
					throw new ObjectDisposedException("", "ɂ̃IuWFNg͔jĂ܂B");
				return this.handle.Target;
			}
		}
		///<summary>
		///̃IuWFNggpĂA}l[Wh\[X܂BIvVŁA}l[Wh\[X܂B
		///</summary>
		///<param name="disposing">}l[Wh\[XƃA}l[Wh\[X̗ꍇ true B</param>
		protected virtual void Dispose(bool disposing) {
			if (this.handle.IsAllocated) {
				if (this.handle.Target != null)
					Marshal.ReleaseComObject(this.handle.Target);
				if (disposing) {
					this.handle.Target = null;
				}
				this.handle.Free();
			}
		}
		///<summary>
		///\[Xj܂B
		///</summary>
		public void Dispose() {
			this.Dispose(true);
			GC.SuppressFinalize(this);
		}
		///<summary>
		///t@CiCUB
		///</summary>
		~ComInterfaceWrapper() {
			this.Dispose(false);
		}
	}
}
